package dev.peerat.parser.java.printer;

import java.util.Iterator;
import java.util.Map;
import java.util.Map.Entry;

import dev.peerat.parser.Token;
import dev.peerat.parser.java.Annotation;
import dev.peerat.parser.java.value.Value;

public class JavaAnnotationPrinter extends JavaPrinter<Annotation>{
	
	@Override
	public void print(Annotation element, Writer writer, String buffer, JavaPrintProvider provider) throws Exception {
		writer.write(buffer);
		writer.write("@");
		writer.write(element.getName());
		Map<Token, Value> map = element.getParameters();
		if(map != null && !map.isEmpty()){
			writer.write("(");
			Iterator<Entry<Token, Value>> iterator = map.entrySet().iterator();
			while(iterator.hasNext()){
				Entry<Token, Value> entry = iterator.next();
				writer.write(entry.getKey());
				writer.write("=");
				Value value = entry.getValue();
				provider.getPrinter(value).print(value, writer, buffer, provider);
				if(iterator.hasNext()) writer.write(",");
			}
			writer.write(")");
		}
		writer.write("\n");
	}
	
}
