package dev.peerat.parser.java.printer;

import dev.peerat.parser.java.ClassBase;
import dev.peerat.parser.java.Import;
import dev.peerat.parser.java.JavaFile;

public class JavaFilePrinter extends JavaPrinter<JavaFile>{

	@Override
	public void print(JavaFile element, Writer writer, String buffer, JavaPrintProvider provider) throws Exception {
		if(element.getPackage() != null){
			writer.write("package ");
			writer.write(element.getPackage());
			writer.write(";\n");
		}
		for(Import imp : element.getImports()){
			provider.getPrinter(imp).print(imp, writer, buffer, provider);
			writer.write("\n");
		}
		
		ClassBase clazz = element.getMainClass();
		provider.getPrinter(clazz).print(clazz, writer, buffer, provider);
		
		for(ClassBase classes : element.getSubClasses()){
			provider.getPrinter(classes).print(classes, writer, buffer, provider);
		}
	}

}
