package dev.peerat.parser.java.tree;

import dev.peerat.parser.TokenType;
import dev.peerat.parser.java.Annotation.AnnotableBuffer;
import dev.peerat.parser.java.AnnotationClass;
import dev.peerat.parser.java.ClassContainer;
import dev.peerat.parser.java.JavaElement;
import dev.peerat.parser.state.StateTree;
import dev.peerat.parser.tree.SyntaxTree;
import dev.peerat.parser.tree.SyntaxTreeRegistery;

public class AnnotationClassTree extends SyntaxTree<JavaElement> {

	public AnnotationClassTree(SyntaxTreeRegistery<JavaElement> registery) {
		super(registery);
		this.current = new StateTree<>();
	}

	@Override
	public void init() {
		StateTree<JavaElement> clazz_container = registery.getNode(ClassContainerTree.class);
		ClassBaseTree clazz_ = registery.getTree(ClassBaseTree.class);
		// ANNOTATION CLAZZ
		StateTree<JavaElement> def_annos = this.current;
		StateTree<JavaElement> def_anno_base = def_annos
				.then((validator) -> validator.validate((token) -> token.getValue().equals("@"))
						&& validator.validate((token) -> token.getValue().equals("interface")))
				.then((validator) -> validator.validate((token) -> token.getType().equals(TokenType.NAME),
						(bag, token) -> bag.set("name", token)));
		def_anno_base.then((validator) -> validator.validate((token) -> token.getValue().equals("{")))
				.<JavaElement>end((parent, bag) -> {
					AnnotationClass current = new AnnotationClass((((AnnotableBuffer) parent).getAnnotationBuffer()),
							bag.get("modifier") == null ? 0 : bag.get("modifier"),
							bag.get("name"));
					if (parent instanceof ClassContainer)
						((ClassContainer) parent).addClass(current);
					return current;
				}).multiple(clazz_container)
				.unique((validator) -> validator.validate((token) -> token.getValue().equals("}"))).end((a, b) -> a);

		clazz_.getNode().then(def_annos);
		clazz_.getModifierNode().then(def_annos);
	}

}
