package dev.peerat.parser.java.tree;

import dev.peerat.parser.tree.TreeType;

public enum JavaTreeType implements TreeType{
	
	ALL(null),
	CLASS_BASE(ClassBaseTree.class),
	CLASS(ClassTree.class),
	INTERFACE(InterfaceTree.class),
	ENUMERATION(EnumTree.class),
	ANNOTATION_CLASS(AnnotationClassTree.class),
	FUNCTION(FunctionTree.class),
	OPERATION(OperationTree.class),
	VARIABLE(VariableTree.class),
	ANNOTATION(AnnotationTree.class),
	VALUE(ValueTree.class),
	TYPE(TypeTree.class),
	GENERIC(GenericTree.class),
	MODIFIER(ModifierTree.class);
	
	private Class<?> type;
	
	JavaTreeType(Class<?> type){
		this.type = type;
	}

	@Override
	public Class<?> getType(){
		return type;
	}
	
}
