package dev.peerat.parser.java.value;

import java.util.ArrayList;
import java.util.List;
import java.util.function.Function;

import dev.peerat.parser.Token;
import dev.peerat.parser.java.Annotation.AnnotableBuffer;
import dev.peerat.parser.java.Function.FunctionContainer;
import dev.peerat.parser.java.Annotation;
import dev.peerat.parser.java.JavaElement;
import dev.peerat.parser.java.Variable;
import dev.peerat.parser.java.Variable.VariableContainer;
import dev.peerat.parser.java.visitor.JavaVisitor;
import dev.peerat.parser.visitor.Visitor;
import dev.peerat.parser.visitor.VisitorBag;

public class InstanceValue extends Value implements VariableContainer, FunctionContainer, AnnotableBuffer{ //TODO LIKE A CLASS, CAN CONTAINS CLASS
	
	private Token token;
	private List<Value> parameters;
	
	private List<JavaElement> elements;
	private List<Annotation> annotationBuffer;
	
	public InstanceValue(Token token, List<Value> parameters){
		this.token = token;
		this.parameters = parameters;
		this.elements = new ArrayList<>();
	}
	
	public Token getToken(){
		return token;
	}
	
	public List<Value> getParameters(){
		return this.parameters;
	}
	
	public List<JavaElement> getElements(){
		return this.elements;
	}
	
	@Override
	public void addFunction(dev.peerat.parser.java.Function function){
		this.elements.add(function);
	}

	@Override
	public void addVariable(Variable variable){
		this.elements.add(variable);
	}
	
	@Override
	public void addAnnotationBuffer(Annotation annotation){
		if(annotationBuffer == null) annotationBuffer = new ArrayList<>();
		annotationBuffer.add(annotation);
	}
	
	public List<Annotation> getAnnotationBuffer(){
		List<Annotation> list = this.annotationBuffer;
		this.annotationBuffer = null;
		return list;
	}

	@Override
	public <E extends JavaElement> E find(Function<JavaElement, Boolean> finder) {
		return null;
	}

	@Override
	public <E extends JavaElement> void findAll(Function<JavaElement, Boolean> finder, List<E> list) {
		
	}

	@Override
	public VisitorBag visit(Visitor<JavaElement> visitor) {
		if(visitor.canVisit(getClass())) return visitor.visit(this);
		VisitorBag bag = new VisitorBag();
		return bag;
	}

}
