package dev.peerat.parser.java.visitor.value;

import java.util.function.Predicate;

import dev.peerat.parser.java.value.InstanceValue;
import dev.peerat.parser.java.visitor.JavaVisitor;
import dev.peerat.parser.visitor.VisitorBag;

public class JavaInstanceValueVisitor extends JavaVisitor<InstanceValue> {
	
	private Predicate<String> namePredicate;
	
	public JavaInstanceValueVisitor(){
		super(InstanceValue.class);
	}
	
	public JavaInstanceValueVisitor named(Predicate<String> predicate){
		this.namePredicate = predicate;
		return this;
	}

	@Override
	public VisitorBag visitElement(InstanceValue element) {
		VisitorBag bag = new VisitorBag();
		
		if(namePredicate != null){
			if(!namePredicate.test(element.getToken().getValue())) return bag;
		}
		
		bag.compute(element);
		return bag;
	}
}
