package dev.peerat.parser.java.visitor.value;

import java.util.function.Predicate;

import dev.peerat.parser.java.value.StaticValue;
import dev.peerat.parser.java.visitor.JavaVisitor;
import dev.peerat.parser.visitor.VisitorBag;

public class JavaStaticValueVisitor extends JavaVisitor<StaticValue> {
	private Predicate<String> tokenPredicate;

	public JavaStaticValueVisitor() {
		super(StaticValue.class);
	}

	public JavaStaticValueVisitor token(Predicate<String> checker) {
		tokenPredicate = checker;
		return this;
	}

	@Override
	public VisitorBag visitElement(StaticValue element){
		VisitorBag bag = new VisitorBag();
		
		if(tokenPredicate != null){
			if(!tokenPredicate.test(element.getToken().getValue())) return bag;
		}
		
		bag.compute(element);
		return bag;
	}
}
